/*
 * Copyright (c) 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef _FLUKE_CP_RPC_H_
#define _FLUKE_CP_RPC_H_

/*
 * Request codes are of the format `req_<Interface>_<operation>'.
 * The enum type can be used to print the symbolic names in the debugger.
 */

enum fluke_req_code {
#define DEFINE_OPERATION(interface, operation, code) \
	req_##interface##_##operation = (code),
#define DEFINE_EXCEPTION(exception, code) /* Omit exceptions here.  */
#include <fluke/cp/rpc.def>
#undef	DEFINE_OPERATION
#undef	DEFINE_EXCEPTION
	req_NoInterface_PlaceHolder /* This avoids a trailing comma.  */
};

/*
 * Reply codes are of the format `exc_fluke_<exception>'.
 * The enum type can be used to print the symbolic names in the debugger.
 */

enum fluke_exc_code {
#define DEFINE_OPERATION(interface, operation, code) /* Omit requests here.  */
#define DEFINE_EXCEPTION(exception, code) \
	exc_fluke_##exception = (code),
#include <fluke/cp/rpc.def>
#undef	DEFINE_OPERATION
#undef	DEFINE_EXCEPTION
	exc_fluke_no_exception	= 0 /* MOM standard */
};


#endif /* _FLUKE_CP_RPC_H_ */
