/*
 * Copyright (c) 1995 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Debugging assist functions.  
 */
#ifndef FLUKE_DEBUG_H
#define FLUKE_DEBUG_H

#include <oskit/compiler.h>
#include <oskit/debug.h>

void fluke_debug_dump_flob(void *sob);

#define FLUKE_DEBUG_PUTS_STR_LEN 100 
void fluke_debug_puts(const char *str);

#define FLUKE_DEBUG_LABEL_STR_MAXLEN 32
void fluke_debug_label_flob(void *sob, const char *str);

void fluke_debug_dump_memuse(void);

void fluke_debug_null_syscall(void);

#include <fluke/machine/debug.h>

#endif /* FLUKE_DEBUG_H */
