/*
 * Copyright (c) 1995 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef _FLUKE_PSET_H_
#define _FLUKE_PSET_H_

#include <oskit/machine/types.h>
#include <fluke/ob.h>

FLUKE_OB_DEFINE(fluke_pset, FLUKE_PSET_SIZE);

struct fluke_pset_state
{
	fluke_hash_t		hash;
};
typedef struct fluke_pset_state fluke_pset_state_t;

struct fluke_ref;

fluke_error_t fluke_pset_create(
	fluke_pset_t		*pset);

fluke_error_t fluke_pset_create_hash(
	fluke_pset_t		*pset,
	fluke_hash_t		*hash);

void fluke_pset_destroy(
	fluke_pset_t		*pset);

void fluke_pset_reference(
	fluke_pset_t		*pset,
	struct fluke_ref	*out_pset_ref);

void fluke_pset_get_state(
	fluke_pset_t		*pset,
	fluke_pset_state_t	*out_state);

void fluke_pset_set_state(
	fluke_pset_t		*pset,
	fluke_pset_state_t	*state);

void fluke_pset_move(
	struct fluke_pset	*old_va,
	struct fluke_pset	*new_va);

#include <fluke/machine/pset.h>

#endif /* _FLUKE_PSET_H_ */
