/*
 * Copyright (c) 1996, 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Thread-safe version of errno provided by the Fluke standalone C library.
 */
#ifndef _FLUKE_SAC_ERRNO_H_
#define _FLUKE_SAC_ERRNO_H_

#include <fluke/sac/pthread.h>

extern pthread_key_t __errno_key;

/*
 * We define errno as a macro with this simple form so that
 * declarations like `int errno;' in old code continue to work harmlessly.
 * The real work is done in the inline function below.
 */
#define errno (*__perthread_errno_loc())

static __inline__ int * __attribute((__unused__))
__perthread_errno_loc(void)
{
	return (int *)pthread_getspecific(__errno_key);
}


/* Pick up all the actual errno codes from the OS toolkit.  */
#include <oskit/c/errno.h>

#endif /* _FLUKE_SAC_ERRNO_H_ */
