/*
 * Copyright (c) 1996 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 *	Pthread condition variables on top of Fluke variables
 */

#ifndef _FLUKE_SAC_PTHREAD_PTHREAD_COND_H
#define _FLUKE_SAC_PTHREAD_PTHREAD_COND_H

typedef struct pthread_condattr {
	long	flags;
} pthread_condattr_t;

typedef struct pthread_cond {
	fluke_cond_t		*fcond;
	pthread_condattr_t	attr;
} pthread_cond_t;

#define PTHREAD_COND_INITIALIZER { 0 }

int     pthread_cond_init 	(pthread_cond_t *, const pthread_condattr_t *);

int     pthread_cond_wait       (pthread_cond_t *, pthread_mutex_t *);
int     pthread_cond_signal     (pthread_cond_t *);
int     pthread_cond_broadcast  (pthread_cond_t *);
int     pthread_cond_destroy    (pthread_cond_t *);

/* LATER 
int     pthread_cond_timedwait  
	(pthread_cond_t *, pthread_mutex_t *, const struct timespec * abstime);
*/

#endif /* _FLUKE_SAC_PTHREAD_PTHREAD_COND_H */

