/*
 * Copyright (c) 1996 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef _FLUKE_X86_VM_H_
#define _FLUKE_X86_VM_H_

/*
 * These symbol define the size of the address space
 * that user tasks are guaranteed to be able to use
 * under the Fluke API on the x86.
 */
#define FLUKE_VM_MIN	((oskit_addr_t) 0x00000000)
#define FLUKE_VM_MAX	((oskit_addr_t) 0x40000000)

/*
 * These symbols define the address range of the Fluke API entrypoint area.
 * Standard tasks in which the entrypoint area is mapped
 * must not attempt to map anything else into this area.
 */
#define FLUKE_ENTRY_MIN	((oskit_addr_t) 0x04000000)
#define FLUKE_ENTRY_MAX	((oskit_addr_t) 0x04004000)

#endif /* _FLUKE_X86_VM_H_ */
