/*
 * Copyright (c) 1996 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef _FLUKE_KERNEL_ACOUNT_H_
#define _FLUKE_KERNEL_ACOUNT_H_

#include "spin_lock.h"

typedef struct acount
{
	spin_lock_t	lock;
	int		counter;
} acount_t;

void acount_init(
	struct acount *ac,
	int value);

/*
 * Increment counter by one.
 * Returns the old value.
 */
int acount_incr(
	struct acount *ac);

/*
 * Decrement counter by one.
 * Returns the new value.
 */
int acount_decr(
	struct acount *ac);

#endif /* _FLUKE_KERNEL_ACOUNT_H_ */
