/*
 * Copyright (c) 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#include "kserver/kserver.h"
#include <fluke/nest/ref_pool.h>
#include <fluke/debug.h>

/*
 * We must provide this initializer function because libnest code calls it.
 */
void
ref_pool_init(void)
{
}


fluke_ref_t *
alloc_scratch_ref(void)
{
	fluke_ref_t *ref;
	int rc;

	ref = smemalign(FLUKE_REF_SIZE, FLUKE_REF_SIZE);
	if (!ref)
		return NULL;
	rc = fluke_ref_create(ref);
	fluke_debug_label_flob(ref, "kserver scratch ref");
	if (rc) {
		sfree(ref, FLUKE_REF_SIZE);
		return NULL;
	}
	return ref;
}


void
free_scratch_ref(fluke_ref_t *ref)
{
	assert(ref);
	fluke_ref_destroy(ref);
	sfree(ref, FLUKE_REF_SIZE);
}

