/*
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef _S_PROFIL_H_
#define _S_PROFIL_H_

#include "config_user_gprof.h"
#ifdef CONFIG_USER_GPROF

#include <oskit/machine/types.h>

#define P_PROFIL 1

int s_profil(oskit_addr_t samples, int size, int offset, int scale);


struct uprof {			/* profile arguments */
	unsigned long pr_base;	/* buffer base */
	unsigned long pr_size;	/* buffer size */
	unsigned long pr_off;	/* pc offset */
	unsigned long pr_scale;	/* pc scaling */
	/* we don't want to muck with the user's memory (it's a pain) */
	void *buffer;		/* in-kernel buffer */
};

#endif CONFIG_USER_GPROF
#endif  _S_PROFIL_H_
