/*
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * This file provides the definition for `boot_cpu_info', which is
 * the per-CPU data structure for the boot CPU (the only one in a
 * uniprocessor kernel).  The base_gdt, base_idt, and base_tss structures
 * are contained within this structure (like a common block), so they
 * can be accessed either directly or through a `fluke_cpu_info_t *' pointer.
 */

#include <oskit/x86/asm.h>

#include "x86.h"

	.bss

	.balign FLUKE_CPU_INFO_ALIGN
	.globl	EXT(boot_cpu_info)
LEXT(boot_cpu_info)
	.ds.b	FLUKE_CPU_INFO_SIZE

	.globl	EXT(base_gdt)
	.globl	EXT(base_tss)
	.equ	EXT(base_gdt),EXT(boot_cpu_info)+CPU_GDT
	.equ	EXT(base_tss),EXT(boot_cpu_info)+CPU_TSS
