/*
 * Copyright (c) 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * This header file simply defines a macro for assembly language
 * equivalent to the current_thread() macro defined in x86/s_thread.h for C.
 */
#ifndef _FLUKE_KERNEL_X86_S_THREAD_ASM_H_
#define _FLUKE_KERNEL_X86_S_THREAD_ASM_H_

#include "config_nonblocking.h"

#ifdef CONFIG_NONBLOCKING

#define CURRENT_THREAD(reg)						\
	movl	%esp,reg						;\
	andl	$-PROCESSOR_STACK_SIZE,reg				;\
	movl	(reg),reg

#else /* not CONFIG_NONBLOCKING */

#define CURRENT_THREAD(reg)						\
	movl	%esp,reg						;\
	andl	$-S_THREAD_SIZE,reg

#endif /* not CONFIG_NONBLOCKING */

#endif /* _FLUKE_KERNEL_X86_S_THREAD_ASM_H_ */
